#ifndef SUPER_SAMPLER_H
#define SUPER_SAMPLER_H

typedef struct sample_data
{
vector3 pos;
	Color c;
};

#include "../common/scene.h"
#include "RayTracer.h"

class SuperSamplingRayTracer : public RayTracer
{
public:
	SuperSamplingRayTracer(Canvas *c) : RayTracer(c)
	{ }
	
	~SuperSamplingRayTracer()
	{ }
	
	void render(SlimScene *scene);
private:
	void sample_row_uniform(int j, list *row);
	void sample_row_jitter(int j, list *row);
	void sample_row_random(int j, list *row);
};

#endif
